﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System.Text
Imports System.Math

Friend Module ServiceFunctions

    Friend Function bMessage(ByVal intPicture As Integer, ByVal strCaption As String, ByVal strMessage As String, ByVal blnOkNo As Boolean) As Boolean
        'информационное диалоговое окно
        Dim Message As frmMessage
        'входные параметры:
        '   intPicture:
        '       1 - пиктограмма "Стоп"
        '       2 - пиктограмма "?"
        '       3 - пиктограмма "!"
        '       4 - пиктограмма "i"
        '   strCaption - Message.Text
        '   strMessage - текст сообщения
        '   blnOkNo:
        '       True - две кнопки: "Да", "Нет"
        '       False - одна кнопка "Закрыть"
        'выходные параметры:
        '   значение функции CurrentMessage, если blnOkNo = True:
        '       True - нажата кнопка "Да" или клавиша "Enter"
        '       False - нажата кнопка "Нет" или клавиша "Esc"
        '   значение функции CurrentMessage, если blnOkNo = False:
        '       True - нажата клавиша "Enter"
        '       False - нажата кнопка "Нет" или клавиша "Esc"
        '       выбран пункт меню "Закрыть"
        Cursor.Current = System.Windows.Forms.Cursors.WaitCursor
        Message = New frmMessage
        With Message
            'формируем информационную иконку
            Select Case intPicture
                Case 1
                    .pic.Image = .pic01.Image
                Case 2
                    .pic.Image = .pic02.Image
                Case 3
                    .pic.Image = .pic03.Image
                Case 4
                    .pic.Image = .pic04.Image
            End Select
            'формируем Message.Text
            .Text = strCaption
            'формируем текст сообщения
            .lbl.Text = strMessage
            'формируем кнопки
            If Not blnOkNo Then
                'одна кнопка "Закрыть"
                'диалоговое окно требуется закрыть:
                '   нажав на кнопку "Нет"
                '   нажав на клавишу "Enter"
                '   нажав на клавишу "Esc"
                '   выбором пункта меню "Закрыть"
                .btnOk.Visible = False
                .btnCancel.DialogResult = DialogResult.OK
                .btnCancel.Text = "Закрыть"
                .AcceptButton = .btnCancel
            End If
            If .ShowDialog() = DialogResult.OK Then
                bMessage = True
            Else
                bMessage = False
            End If
        End With
    End Function

    Friend Function F(ByVal x As String) As Double
        'вычисление F(x), например, при x = "1.53+sin(4.54)*cos(67)-123.5"
        Dim Script As New MSScriptControl.ScriptControl
        With Script
            .Language = "VBScript"
            x = x.Replace(",", ".")
            .ExecuteStatement("x=" & x)
            F = CDbl(.Eval(x))
        End With
    End Function

    Friend Function func(ByRef sF As String, ByRef xk() As Double, ByVal blnMessage As Boolean) As Double
        'вычисление функции
        Try
            Return F(sReplace(New StringBuilder(sF), xk).ToString)
        Catch ex As Exception
            If blnMessage Then bMessage(1, globProblem, "Отредактируйте описание функции", False)
            berror = True
            Return 0
        End Try
    End Function

    Friend Function sReplace(ByRef s As StringBuilder, ByRef xk() As Double) As StringBuilder
        'замена: xi <- xk(i)
        For i As Integer = 0 To n - 1
            s.Replace("x" & i + 1, xk(i).ToString)
        Next
        Return s
    End Function

    Friend Function bh(ByRef hi() As Double, ByVal epsh As Double) As Boolean
        'bh = True -> Abs(hi(i)) < epsh
        For i As Integer = 0 To n - 1
            If Abs(hi(i)) > epsh Then Return False
        Next
        Return True
    End Function

End Module
