﻿Option Explicit On
Option Compare Binary
Option Strict On
Imports System.IO
Imports System.Windows.Forms
Imports System.Windows.Forms.Keys

Public Class frmF

    Dim dv As New DataView

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        With Me
            AddHandler .Load, AddressOf Me_Load
            AddHandler .FormClosing, AddressOf Me_FormClosing
            AddHandler .KeyDown, AddressOf Me_KeyDown
        End With
        AddHandler btnCancel.Click, AddressOf btnCancel_Click
        AddHandler btnUpdate.Click, AddressOf btnUpdate_Click
        AddHandler btnDb.Click, AddressOf btnDb_Click
        AddHandler btnIdb.Click, AddressOf btnIdb_Click
        AddHandler GrdEdit.KeyDown, AddressOf grdEdit_KeyDown

    End Sub

    Private Sub Me_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        If e.KeyCode = Escape Then Close()
    End Sub

    Private Sub Me_Load(ByVal sender As Object, ByVal e As EventArgs)
        With dv
            'параметры настройки
            .Table = globds.idbF
            .RowFilter = "Id = " & "'" & globGuid.ToString & "'"
        End With
        Call InitializeGrdGrdEdit()
        Call ModeWork(True)
    End Sub

    Private Sub InitializeGrdGrdEdit()
        With dv
            If .Count = 0 Then
                Dim row As DataRowView
                .BeginInit()
                row = .AddNew()
                row("Id") = globGuid
                row("colValue") = ""
                row.EndEdit()
                .EndInit()
                intUpdate = 1
                Grd.Text = ""
                GrdEdit.Text = ""
            Else
                Grd.Text = dv(0)("colValue").ToString
                GrdEdit.Text = Grd.Text
            End If
        End With
    End Sub

    Private Sub ModeWork(ByVal blnMode As Boolean)
        'инициализация
        With btnUpdate
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With btnDb
            If blnMode Then .Enabled = False Else .Enabled = True
        End With
        With btnIdb
            If blnMode Then .Enabled = True Else .Enabled = False
        End With
        With GrdEdit
            If blnMode Then .ReadOnly = True Else .ReadOnly = False
        End With
    End Sub

    Private Sub Me_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        Call UpdateIdb()
        Opacity = 0
        Dispose()
    End Sub

    Private Sub UpdateIdb()
        'редактирование информационной базы данных
        If intUpdate <> 0 Then
            If bMessage(2, "Редактирование", "Вы хотите сохранить изменения в информационной базе данных?", True) Then
                intUpdate = 0
                globds.AcceptChanges()
                If File.Exists(strPathXml) Then File.Delete(strPathXml)
                globds.WriteXml(strPathXml, XmlWriteMode.DiffGram)
            End If
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As EventArgs)
        'отмена
        intUpdate = 0
        globds.RejectChanges()
            Call InitializeGrdGrdEdit()
        Call ModeWork(True)
    End Sub

    Private Sub btnUpdate_Click(ByVal sender As Object, ByVal e As EventArgs)
        'редактирование записи
        If dv.Count <> 0 Then
            Call ModeWork(False)
            GrdEdit.Focus()
        End If
    End Sub

    Private Sub btnDb_Click(ByVal sender As Object, ByVal e As EventArgs)
        'редактирование строки в grd
        Grd.Text = GrdEdit.Text
        dv(0)("colValue") = Grd.Text
        Call ModeWork(True)
        intUpdate = 1
    End Sub

    Private Sub btnIdb_Click(ByVal sender As Object, ByVal e As EventArgs)
        Call UpdateIdb()
    End Sub

    Private Sub grdEdit_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
        'редактирование grd
        If e.KeyCode = Keys.Enter Then
            If bMessage(2, "Редактирование", "Внести изменения в локальную базу данных? Enter - Да, Ecs - Нет", True) Then
                btnDb.PerformClick()
            End If
            e.Handled = True
        End If
    End Sub

End Class